#include <stdio.h>
#include <unistd.h>
#include <errno.h>
#include <stdlib.h>
#include <fcntl.h>

void error_fatal (const char *message){
  perror (message);
  exit (1);
}

int main(){
  int fd;

  /* Otvaranje fajla, brisanje sadrzaja i kreiranje fajla ako nije postojao. */
  if ( (fd = open ("izlaz.txt", O_WRONLY | O_CREAT | O_TRUNC, 0644)) < 0)
    error_fatal ("open error");

  printf ("Poruka u komandnoj liniji.\n");
  /* Forsiranje praznjenja bafera koji se odnosi na standardni izlaz moze se uraditi pomocu:
     fflush (stdout); */

  /* Preusmerava se fajl deskriptor koji se inace odnosi na standardni izlaz da pokazuje na otvorenu datoteku.*/
  if (dup2 (fd, STDOUT_FILENO) < 0)
    error_fatal ("dup2 error");

  printf ("Upis u datoteku iz procesa: %d\n", getpid());

  return 0;
}
