#include <stdio.h>
#include <unistd.h>
#include <errno.h>
#include <stdlib.h>
#include <fcntl.h>

void error_fatal (const char *message){
  perror (message);
  exit (1);
}

int main(){
  int fd;
  int zapamcen_fd;

  /****************************************************************************************/
  // Korisna naredba je fflush (stdout) koja sluzi za praznjenje bafera za standardni izlaz.

  /* Otvaranje fajla, brisanje sadrzaja i kreiranje fajla ako nije postojao. */
  if ( (fd = open ("izlaz.txt", O_WRONLY | O_CREAT | O_TRUNC, 0644)) < 0)
    error_fatal ("open error");

  printf ("Poruka u komandnoj liniji.\n");
  // Da bi bili sigurni da ce bafer da se isprazni, mozemo dodati naredbu fflush (stdout) posle svakog printf-a - o tome vise reci na narednim casovima

  /* Kopira se fajl deskriptor koji se inace odnosi na standardni izlaz u fajl deskriptor zapamcen_fd. */
  if ( (zapamcen_fd = dup (STDOUT_FILENO)) < 0)
    error_fatal ("dup error");

  /* Preusmerava se fajl deskriptor koji se inace odnosi na standardni izlaz da pokazuje na otvorenu datoteku.*/
  if (dup2 (fd, STDOUT_FILENO) < 0)
    error_fatal ("dup2 error: fd to STDOUT_FILENO");

  printf ("Upis u datoteku iz procesa: %d\n", getpid());

  /* Preusmerava se zapamceni fajl deskriptor u fajl deskriptor koji se odnosi na standardni izlaz. */
  if (dup2 (zapamcen_fd, STDOUT_FILENO) < 0)
    error_fatal ("dup2 error: zapamcen_fd to STDOUT_FILENO");

  printf ("Upis u datoteku zavrsen.\n");

  close (fd);
  close (zapamcen_fd);

  return 0;
}
