#include <stdio.h>
#include <unistd.h>
#include <errno.h>
#include <stdlib.h>
#include <fcntl.h>

#define BUFF_SIZE 30

void error_fatal (const char *message){
  perror (message);
  exit (1);
}

int main(){
  int n;
  int fd;
  char buffer [BUFF_SIZE];

  /* Ucitavanje rednog broja studenta. */
  if (scanf ("%d",&n) < 0)
    error_fatal ("scanf error");

  /* Otvaranje datoteke, pretpostavka je da datoteka postoji. */
  if ( (fd = open ("studenti.txt", O_RDONLY)) < 0)
    error_fatal ("open error");

  /* Pozicioniranje na odgovarajuce mesto u fajlu. */
  if ( lseek (fd, (n-1)*30, SEEK_SET) < 0)
    error_fatal ("lseek error");

  /* Citanje reda koji se odnosi na trazenog studenta. */
  if (read (fd, buffer, sizeof (buffer)) != sizeof (buffer))
    error_fatal ("read error");
  
  /* Ispis nadjenog reda na ekran. */
  if (write (STDOUT_FILENO, buffer, sizeof (buffer)) != sizeof (buffer))
    error_fatal ("write error");
  
  close (fd);

  return 0;
}
